// Solution AUSSI accepte : on ne change pas 'Legume' en 'Legume*' mme si C++ n'est pas co-variant (voir le cours de L2/POO : http://109.26.133.25/fbarbier/Programming/Cpp.html#Covariance) sur les types "pleins" retourns...
class Legume {
public: // Changer 'Legume' en 'Legume*' car la fonction 'graine' est dclare virtuelle pure...
	virtual Legume* graine() const = 0;
};
class Legume_feuille : public Legume {
	// Conserver le statut abstrait hrit de la classe 'Legume' en ne touchant **PAS**  la fonction 'graine' !
};
class Celeri : public Legume_feuille {
	// Supprimer le statut abstrait hrit de la classe 'Legume' :
	Celeri* graine() const; // Remarque : 'virtual' ne sert  rien car, a priori, on n'hrite pas de 'Celeri'
};
Celeri* Celeri::graine() const {
	return const_cast<Celeri*>(this); // C'est mieux d'utiliser 'const_cast' mais 'return (Celeri*)this;' est AUSSI une instruction considre "juste"...
}

int main() {
	Celeri c;
	Legume& l1 = c;
	Legume* l2 = reinterpret_cast<Legume*>(l1.graine()); // Polymorphisme ici (question 2)...
}

// Question 3 :
class Fruit {
public:
	virtual void fonction_quelconque() = 0; // Juste pour simuler que la classe 'Fruit' est abstraite...
};
class Legume_fruit : virtual public Fruit, virtual public Legume { // Hritage virtuel plus sr s'il y a des champs...
};
class Aubergine : public Legume_fruit {
	void fonction_quelconque();
	Aubergine* graine() const;
};
void Aubergine::fonction_quelconque() {
	// Etc.
}
Aubergine* Aubergine::graine() const {
	return const_cast<Aubergine*>(this);
}